
%global pkg_name aeson
%global pkgver %{pkg_name}-%{version}

%global indexedtraversableinstances indexed-traversable-instances-0.1.1.2
%global OneTuple OneTuple-0.4.1.1
%global semialign semialign-1.3
%global witherable witherable-0.4.2
%global generically generically-0.1.1
%global subpkgs %{OneTuple} %{indexedtraversableinstances} %{semialign} %{witherable} %{generically}


Name:           ghc-%{pkg_name}
Version:        2.1.2.1
Release:    1%{?dist}
Summary:        Fast JSON parsing and encoding

License:        BSD-3-Clause
Url:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkgver}/%{pkgver}.tar.gz
Source1:        https://hackage.haskell.org/package/%{OneTuple}/%{OneTuple}.tar.gz
Source2:        https://hackage.haskell.org/package/%{semialign}/%{semialign}.tar.gz
Source3:        https://hackage.haskell.org/package/%{witherable}/%{witherable}.tar.gz
Source4:        https://hackage.haskell.org/package/%{indexedtraversableinstances}/%{indexedtraversableinstances}.tar.gz
Source5:        https://hackage.haskell.org/package/%{generically}/%{generically}.tar.gz
Source6:        https://hackage.haskell.org/package/%{pkgver}/%{pkg_name}.cabal#/%{pkgver}.cabal

BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros-extra
BuildRequires:  ghc-QuickCheck-devel
BuildRequires:  ghc-attoparsec-devel
BuildRequires:  ghc-base-devel
BuildRequires:  ghc-base-compat-batteries-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-data-fix-devel
BuildRequires:  ghc-deepseq-devel
BuildRequires:  ghc-dlist-devel
BuildRequires:  ghc-exceptions-devel
BuildRequires:  ghc-hashable-devel
BuildRequires:  ghc-indexed-traversable-devel
BuildRequires:  ghc-primitive-devel
BuildRequires:  ghc-scientific-devel
BuildRequires:  ghc-strict-devel
BuildRequires:  ghc-tagged-devel
BuildRequires:  ghc-template-haskell-devel
BuildRequires:  ghc-text-devel
BuildRequires:  ghc-text-short-devel
BuildRequires:  ghc-th-abstraction-devel
BuildRequires:  ghc-these-devel
BuildRequires:  ghc-time-devel
BuildRequires:  ghc-time-compat-devel
BuildRequires:  ghc-unordered-containers-devel
BuildRequires:  ghc-uuid-types-devel
BuildRequires:  ghc-vector-devel
%if %{with ghc_prof}
BuildRequires:  ghc-QuickCheck-prof
BuildRequires:  ghc-attoparsec-prof
BuildRequires:  ghc-base-prof
BuildRequires:  ghc-base-compat-batteries-prof
BuildRequires:  ghc-bytestring-prof
BuildRequires:  ghc-containers-prof
BuildRequires:  ghc-data-fix-prof
BuildRequires:  ghc-deepseq-prof
BuildRequires:  ghc-dlist-prof
BuildRequires:  ghc-exceptions-prof
BuildRequires:  ghc-hashable-prof
BuildRequires:  ghc-indexed-traversable-prof
BuildRequires:  ghc-primitive-prof
BuildRequires:  ghc-scientific-prof
BuildRequires:  ghc-strict-prof
BuildRequires:  ghc-tagged-prof
BuildRequires:  ghc-template-haskell-prof
BuildRequires:  ghc-text-prof
BuildRequires:  ghc-text-short-prof
BuildRequires:  ghc-th-abstraction-prof
BuildRequires:  ghc-these-prof
BuildRequires:  ghc-time-prof
BuildRequires:  ghc-time-compat-prof
BuildRequires:  ghc-unordered-containers-prof
BuildRequires:  ghc-uuid-types-prof
BuildRequires:  ghc-vector-prof
%endif
BuildRequires:  ghc-semigroupoids-devel
BuildRequires:  ghc-transformers-devel
%if %{with ghc_prof}
BuildRequires:  ghc-semigroupoids-prof
BuildRequires:  ghc-transformers-prof
%endif
BuildRequires:  ghc-base-orphans-devel
BuildRequires:  ghc-transformers-devel
%if %{with ghc_prof}
BuildRequires:  ghc-base-orphans-prof
BuildRequires:  ghc-transformers-prof
%endif
BuildRequires:  ghc-base-orphans-devel
%if %{with ghc_prof}
BuildRequires:  ghc-base-orphans-prof
%endif

%description
A JSON parsing and encoding library optimized for ease of use and
high performance.  Aeson was the father of Jason in Greek mythology.


%package devel
Summary:        Haskell %{pkg_name} library development files
Provides:       %{name}-static = %{version}-%{release}
Provides:       %{name}-static = %{version}-%{release}
%if %{defined ghc_version}
Requires:       ghc-compiler = %{ghc_version}
%endif
Requires:       %{name} = %{version}-%{release}

%description devel
This package provides the Haskell %{pkg_name} library development files.


%if %{with haddock}
%package doc
Summary:        Haskell %{pkg_name} library documentation
BuildArch:      noarch
Requires:       ghc-filesystem

%description doc
This package provides the Haskell %{pkg_name} library documentation.
%endif


%if %{with ghc_prof}
%package prof
Summary:        Haskell %{pkg_name} profiling library
Requires:       %{name}-devel = %{version}-%{release}
Supplements:    (%{name}-devel and ghc-prof)

%description prof
This package provides the Haskell %{pkg_name} profiling library.
%endif


%global main_version %{version}

%if %{defined ghclibdir}
%ghc_lib_subpackage -l BSD-2-Clause %{indexedtraversableinstances}
%ghc_lib_subpackage -l BSD-3-Clause %{OneTuple}
%ghc_lib_subpackage -l BSD-3-Clause %{semialign}
%ghc_lib_subpackage -l BSD-3-Clause %{witherable}
%ghc_lib_subpackage -l BSD-3-Clause %{generically}
%endif

%global version %{main_version}


%prep
%setup -q -n %{pkgver} -a1 -a2 -a3 -a4 -a5
cp -bp %{SOURCE6} %{pkg_name}.cabal
(
cd %{witherable}
cabal-tweak-dep-ver base-orphans '<0.9' '<0.10'
cabal-tweak-dep-ver hashable '<1.4' '<1.5'
cabal-tweak-dep-ver vector '<0.13' '<0.14'
)


%build
%ghc_libs_build %{subpkgs}
%ghc_lib_build


%install
%ghc_libs_install %{subpkgs}
%ghc_lib_install


%files -f %{name}.files
%license LICENSE


%files devel -f %{name}-devel.files
%doc README.markdown changelog.md


%if %{with haddock}
%files doc -f %{name}-doc.files
%license LICENSE
%endif


%if %{with ghc_prof}
%files prof -f %{name}-prof.files
%endif


%changelog
* Mon Apr 15 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.2.1-1
- initial build
